<script setup lang="ts">

import { computed, watch, ref } from "vue";
import { useProductStore } from '@/stores/product';
import { onMounted } from 'vue';
import { useCategoryStore } from "@/stores/category";
import { useCartStore } from "@/stores/cart";
import LoginDialog from "./LoginDialog.vue";
import { useLoginStore } from "@/stores/login";
import { useUserStore } from "@/stores/user";
import RegisterDialog from "./RegisterDialog.vue";
import { useAuthStore } from "@/stores/auth";
const productStore = useProductStore();
const categoryStore = useCategoryStore();
const backendURL = import.meta.env.VITE_BACKEND_URL;
const category = ref(0);
const home = ref(0)
const playstation = ref(2);
const xbox = ref(1);
const nintendo = ref(3);
const collections = ref(6);
const accessories = ref(5);
const authStore = useAuthStore()
const userStore = useUserStore()

function print(length: number) {
  console.log(length)
}
onMounted(() => {
  productStore.getProducts()
  cartStore.getCartItem()
  cartStore.cartItemCount
})
// onMounted(async () => {
//     // await productStore.getProducts();
//     await categoryStore.getCategory();
//     await productStore.getProductsByCategory(productStore.category);
// });

// const cartStore = useCartStore();
// const cartItemCount = computed(() => {
//     return cartStore.cartItem.length;
// });

const cartStore = useCartStore()
</script>

<template>
  <v-container fluid>
    <v-card theme="light" height="1700">
      <v-row class="mt-5">
        <v-col cols="5"></v-col>
        <v-col><span class="fontTitle ml-10">Nova - Consoler</span></v-col>
        <v-col cols="3">
          <!-- อันนี้ icon ขึ้นแต่ไม่มีตัวเลข -->
          <!-- <v-btn class="font" icon="mdi-cart" to="/cartview"></v-btn> -->

          <!-- อันนี้ icon ไม่ขึ้นแต่มีตัวเลข -->
          <v-btn class="font" icon="mdi-cart" to="/cartview" style="position: relative">
            <span><v-icon icon="mdi-cart"></v-icon></span>
            <span class="cart-counter" v-if="cartStore.cartItemCount > 0"
              >{{ cartStore.cartItemCount }}
            </span>
          </v-btn>

                <v-btn @click="authStore.dialog = true" class="ml-4 font">เข้าสู่ระบบ</v-btn>
                <LoginDialog></LoginDialog>
                <v-btn @click="userStore.dialog = true" class="ml-4 font">สมัครสมาชิก</v-btn>
                <RegisterDialog></RegisterDialog>
            </v-col>

      </v-row>

      <v-row>
        <v-col cols="4"></v-col>
        <v-col cols="5"
          ><v-autocomplete
            auto-select-first
            density="comfortable"
            item-props
            menu-icon=""
            placeholder="ค้นหาที่นี่"
            prepend-inner-icon="mdi-magnify"
            rounded
            theme="light"
            variant="solo"
            class="custom-width"
          ></v-autocomplete
        ></v-col>
        <v-col></v-col>
      </v-row>
      <v-container class="text-center">
        <v-row justify="center" dense>
          <v-list-item
            @click="(category = home), productStore.getProducts()"
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-home-circle" size="50px"></v-icon>
            <div class="fontbtn">Home</div>
          </v-list-item>

          <v-list-item
            @click="(category = playstation), productStore.getProductsByCategory(category)"
            to=""
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-sony-playstation" size="50px"></v-icon>
            <div class="fontbtn">Playstation</div>
          </v-list-item>
          <v-list-item
            @click="(category = xbox), productStore.getProductsByCategory(category)"
            to=""
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-microsoft-xbox" size="50px"></v-icon>
            <div class="fontbtn">XBOX</div>
          </v-list-item>
          <v-list-item
            @click="(category = nintendo), productStore.getProductsByCategory(category)"
            to=""
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-nintendo-switch" size="50px"></v-icon>
            <div class="fontbtn">Nintendo</div>
          </v-list-item>
          <v-list-item
            @click="(category = accessories), productStore.getProductsByCategory(category)"
            to=""
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-earbuds" size="50px"></v-icon>
            <div class="fontbtn">Accessories</div>
          </v-list-item>
          <v-list-item
            @click="(category = collections), productStore.getProductsByCategory(category)"
            value="3"
            height="130px"
            width="150px"
            class="list-item-hover"
          >
            <v-icon icon="mdi-gift-outline" size="50px"></v-icon>
            <div class="fontbtn">Collections</div>
          </v-list-item>

          <v-list-item to="/management" height="130px" width="150px" class="list-item-hover">
            <v-icon icon="mdi-account-cog" size="50px"></v-icon>
            <div class="fontbtn">Management</div>
          </v-list-item>
        </v-row>
      </v-container>
      <v-row v-if="category == home">
        <v-col col></v-col>
        <v-col cols="6" class="ml-4"
          ><v-card
            theme="light"
            height="500"
            width="900"
            style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1)"
          >
            <v-carousel>
              <v-carousel-item src="Cyberpunk 2077 Collector_s Edition.jpg" cover></v-carousel-item>
              <v-carousel-item
                src="Final Fantasy XVI Collector Edition.jpg"
                cover
              ></v-carousel-item>
              <v-carousel-item
                src="Ghost of Tsushima Collector_s Edition.jpg"
                cover
              ></v-carousel-item>
              <v-carousel-item
                src="God Of War Ragnarök Collector_s Edition.jpg"
                cover
              ></v-carousel-item>
              <v-carousel-item
                src="The Last Of Us Part II Collector Edition.jpg"
                cover
              ></v-carousel-item>
              <v-carousel-item
                src="Nintendo Switch (OLED model) Pokémon Scarlet & Violet Edition.jpg"
                cover
              ></v-carousel-item>
            </v-carousel> </v-card
        ></v-col>
        <v-col cols="5" class="ml-4">
          <v-card
            theme="light"
            height="500"
            width="600"
            style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1)"
          >
            <v-img height="550px" src="2.png"></v-img> </v-card
        ></v-col>
      </v-row>

      <v-row class="mt-16">
        <v-col col></v-col>
        <v-col cols="10" class="ml-4">
          <!-- <v-card theme="light" height="750" width="1200"
                    style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1);" class="overflow-y-auto"> -->
          <v-card
            theme="light"
            height="750"
            width="1600"
            style="border-radius: 50px; border: 1px solid rgba(0, 0, 0, 0.1)"
            class="overflow-y-auto"
          >
            <h1 v-if="productStore.products.length === 0" style="text-align: center">
              ไม่มีสินค้าในหมวดหมู่นี้
            </h1>
            <v-row>
              <v-col cols="2" fluid v-for="item of productStore.products" :key="item.id">
                <!-- <v-card class="ma-5">
                                <div style="display: grid; place-items: center;">
                                    <v-img cover height="250px" width="200px" class="ma-3"
                                        :src="`${backendURL}/products/image/${item.image}`">
                                    </v-img>
                                </div>
                                <v-card-actions>
                                    <v-btn @click="productStore.getProductDetail(item)" class="fontD" height="50" block
                                        to="/productsaledetail" style="text-align: center;">
                                        {{ item.name }} <br> ฿{{ item.price.toLocaleString() }}
                                    </v-btn>
                                </v-card-actions>
                            </v-card> -->
                <v-card class="card ma-5">
                  <v-btn
                    @click="productStore.getProductDetail(item)"
                    to="/productsaledetail"
                    class="card-img"
                  >
                    <v-img
                      cover
                      height="250px"
                      width="200px"
                      class="ma-3"
                      :src="`${backendURL}/products/image/${item.image}`"
                    >
                    </v-img>
                  </v-btn>

                  <div
                    class="text-title ma-2"
                    style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis"
                  >
                    {{ item.name }}
                  </div>
                  <div class="text-title">฿{{ item.price.toLocaleString() }}</div>
                </v-card>
              </v-col>
            </v-row>
          </v-card>
        </v-col>
        <v-col></v-col>
      </v-row>
    </v-card>
  </v-container>
</template>

<style scoped>
.list-item-hover {
  cursor: pointer; 
}

.list-item-hover:hover {
  animation: listItemHoverAnimation 0.3s ease-in-out;
}

@keyframes listItemHoverAnimation {
  0% {
    transform: scale(1);
  }
  50% {
    transform: scale(1.1);
  }
  100% {
    transform: scale(1);
  }
}



.custom-width {
  width: 650px;
}

.sizetext {
  font-size: 100px;
}

.fontTitle {
  text-align-last: center;
  font-family: fantasy;
  font-size: 35px;
  color: black;
}

.fontbtn {
  text-align-last: center;
  font-family: fantasy;
  font-size: 20px;
  color: black;
}
.font-thai {
  font-family: 'Roboto', sans-serif;
  font-size: 16px;
  font-weight: bold;
}
.font {
  text-align-last: center;
  font-family: fantasy;
  font-size: 18px;
  color: black;
}

.body {
  background: url(https://wallpapers.com/images/hd/ps4-theme-btpkghdtrxbl7n4r.jpg) no-repeat;
  min-height: 100vh;
  display: flex;
  align-items: center;
  justify-content: center;
  background-size: cover;
  /* background-color: bisque; */
}

.cart-counter {
  position: absolute;
  top: -8px;
  right: -8px;
  background-color: black;
  color: white;
  border-radius: 50%;
  width: 20px;
  height: 20px;
  font-size: 12px;
  display: flex;
  justify-content: center;
  align-items: center;
}

.card {
  width: 250px;
  height: 380px;
  padding: 0.9em;
  background: #bce8f0bd;
  position: relative;
  overflow: visible;
  box-shadow:
    0 px 3px rgba(0, 0, 0, 0.12),
    0 1px 2px rgba(0, 0, 0, 0.24);
}

.card-img {
  background-color: #1294df;
  height: 80%;
  width: 100%;
  border-radius: 0.9rem;
}

.card-info {
  padding-top: 10%;
}

svg {
  width: 20px;
  height: 20px;
}

.card-footer {
  width: 100%;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding-top: 10px;
  border-top: 1px solid #ddd;
}

/*Text*/
.text-title {
  font-weight: 600;
  font-size: 1 em;
  line-height: 1.5;
  text-align: center;
}

.text-body {
  font-size: 0.9em;
  padding-bottom: 10px;
}

/*Button*/
.card-button {
  border: 1px solid #252525;
  display: flex;
  padding: 0.3em;
  cursor: pointer;
  border-radius: 50px;
  transition: 0.3s ease-in-out;
}

/*Hover*/
.card-img:hover {
  transform: translateY(-10%);
  box-shadow:
    rgba(226, 196, 63, 0.25) 0px 13px 47px -5px,
    rgba(180, 71, 71, 0.3) 0px 8px 16px -8px;
}

.card-button:hover {
  border: 1px solid #ffcaa6;
  background-color: #ffcaa6;
}
</style>
